
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>CCNET+MSBuild+SVN实时构建的优化总结 / 憋错料</title>

    <meta name="description" content="CCNET+MSBuild+SVN实时构建的优化总结 本文不是介绍如何使用CCNET+MSBuild+SVN构建自动编译系统,相关的内容可以从很多地方获取,可以再园子里搜一下. 随着我们的SVN库日益壮大,容量达到10G,几十G 甚至更大时,我们发现自动构建速度越来越慢,直到有一天你发现入了很小一段代码却不得不等待几小时构建完成,程序员的忍受是有极限的,因此我们决定采取措施实施优化. 首先,我们必须分析哪些因素导致了我们构建速度的减慢,罗列一下,大概如下几个方面: 1. SVN库太大,使得构建服务器在更新SVN代码时花费大量时间. 2. SVN库里">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">CCNET+MSBuild+SVN实时构建的优化总结</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>本文不是介绍如何使用CCNET+MSBuild+SVN构建自动编译系统，相关的内容可以从很多地方获取，可以再园子里搜一下。</p>
<p>随着我们的SVN库日益壮大，容量达到10G,几十G 甚至更大时，我们发现自动构建速度越来越慢，直到有一天你发现入了很小一段代码却不得不等待几小时构建完成，程序员的忍受是有极限的，因此我们决定采取措施实施优化。</p>
<p>首先，我们必须分析哪些因素导致了我们构建速度的减慢，罗列一下，大概如下几个方面：</p>
<p>1. SVN库太大，使得构建服务器在更新SVN代码时花费大量时间。</p>
<p>2. SVN库里有很多工程，每当有SVN代码更新的时候，CCNET就会调用MSBuild将我们所有的工程都编译一遍。（即使入库的文件根本不需要编译，如python脚本）</p>
<p>3. SVN库中工程量越来越大，导致编译所有工程时间原来越长。</p>
<p>对于第三点，我们没有办法，但对于前两点，我们是有办法解决的，总结一下要做的事情：一是加快SVN更新速度，二是减少不必要的工程编译次数。</p>
<h4>一、加快SVN更新速度</h4>
<p>SVN的更新操作是有CCNET发起的，服务每隔一段时间查询一次SVN是否更新（看CCNET源码好像是调用svn --log来获取代码更新信息），如果有文件更新，则调用svn --update进行更新。从CCNET源码看来，CCNET对SVN代码的更新应该是针对性的，即，查询到哪部分代码有更新，就只更新那部分代码。这样的话效率应该不差。但在实际过程中，发现CCNET调用SVN更新速度异常的慢，甚至让我怀疑它是对整个SVN库执行了一次update操作。</p>
<p>要加快SVN更新速度，我们想到的是减少SVN更新的文件范围，假如你入库了一个python代码，或是QTP测试案例，因为无需编译，所以构建服务器甚至不需要更新那部分代码。因此，我们可以在CCNET的配置文件中只配置我们需要编译的工程：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg" /></p>
<p>Code highlighting produced by Actipro CodeHighlighter (freeware)<br />
http://www.CodeHighlighter.com/</p>
<p>--&gt;&lt;sourcecontrol&nbsp;type="multi"&gt; &nbsp;&nbsp;&nbsp;&nbsp;&lt;sourceControls&gt; &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;svn&gt; &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;trunkUrl&gt;http://xxx/projectA&lt;/trunkUrl&gt; &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;workingDirectory&gt;x:\ccnet\svn\projctA&lt;/workingDirectory&gt; &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;username&gt;name&lt;/username&gt; &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;password&gt;pwd&lt;/password&gt; &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;executable&gt;x:\ccnet\Subversion\svn.exe&lt;/executable&gt; &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;/svn&gt; &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;svn&gt; &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;trunkUrl&gt;http://xxx/projectB&lt;/trunkUrl&gt; &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;workingDirectory&gt;x:\ccnet\svn\projctB&lt;/workingDirectory&gt; &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;username&gt;name&lt;/username&gt; &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;password&gt;pwd&lt;/password&gt; &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;executable&gt;x:\ccnet\Subversion\svn.exe&lt;/executable&gt; &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;/svn&gt; &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; &lt;svn&gt; &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;trunkUrl&gt;http://xxx/projectC&lt;/trunkUrl&gt; &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;workingDirectory&gt;x:\ccnet\svn\projctC&lt;/workingDirectory&gt; &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;username&gt;name&lt;/username&gt; &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;password&gt;pwd&lt;/password&gt; &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;executable&gt;x:\ccnet\Subversion\svn.exe&lt;/executable&gt; &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;/svn&gt; &nbsp;&nbsp;&nbsp;&nbsp;&lt;/sourceControls&gt; &lt;/sourcecontrol&gt;</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg" /></p>
<p>通过上面的设置，CCNET就是监视我们上面指定的SVN路径的代码更新了，如果你的SVN库中有大量不需要编译的文件，这样的优化带来的效果是巨大的。</p>
<h4>二、减少编译次数</h4>
<p>上面解决了对入库不需要编译的代码文件的问题，但我们还需要面临一个问题是，当你入库工程A的代码时，你只希望编译工程A，而不是将工程A，B，C都编译一遍。甚至，可能还有更加严格的要求。比如，我们库中有个公共库的工程FrameworkA，工程ProjectA，ProjectB，ProjectC都使用到了该公共库工程。我们希望做到：</p>
<p>1. 当我入库的代码属于FrameworkA时，希望把ProjectA，ProjectB，ProjectC都编译一遍。（因为我修改了公共库，很有可能导致工程A,B,C编译不过。）</p>
<p>2. 当我入库的是ProjectA(或B,C)时，我只希望编译ProjectA(或B,C)就行了。</p>
<p>我们看到我们的工程之间多了一些内在的联系，如何才能处理这种复杂的编译关系呢？我想到的是，要么在CCNET上做手脚，要么在MSBuild上进行扩展。CCNET是一个开源项目，我完全可以修改它的代码为我所用，甚至修改出一个更适合使用的版本提交上去 ，但发现这样做的工程量太大，需要花费的精力太多。我需要找到一个简单的，又容易实现的方案，达到我们上面的两点需求。因此，我选择了对MSBuild进行扩展，而MSBuild本事又是支持这种扩展的，这给我带来了很大的方便。</p>
<p>熟悉MSBuild配置文件的朋友一定知道里面有很多Task供我们使用，比如:CallTarget，Exec，MakeDir，VCBuild等等。同时，也提供机制让我们实现自己的自定义Task。详细使用可以参考微软的文档：<a href="http://msdn.microsoft.com/en-us/library/t9883dzc.aspx" rel="external nofollow noreferrer">How to write a Task</a></p>
<p>现在，我们可以实现一个自己的Task了，那么在我们自定义的这个Task里，我们应该做些什么呢？恩，再来整理一下思路：</p>
<p>1. 我们需要知道更新的代码属于哪个工程。</p>
<p>2. 我们需要知道编译该工程的同时，还需要编译哪些与之相关的工程。</p>
<p>首先解决第一个问题，如何知道更新的代码属于哪个工程？其实，一个更加实际的问题，如何知道更新了哪些代码？ 我曾经尝试过使用CCNET一样的办法，调用svn --log对入库记录进行查询，然后每次保存好上次更新的状态，再判断这次更新相对于上次改动了哪些。做到这些其实非常容易，但是，存在一个问题，CCNET本身也有一个机制在记录着SVN更新的状态（state文件），如果我又记录一个自己的SVN更新历史的文件，可能和CCNET本身记录的有时间差，使得整个流程下来对于要更新的和编译的代码文件变得非常不确定。因此，我最后打算直接使用CCNET获取到的文件更新列表。要获取CCNET获取的SVN更新列表，只需要在CCNET的配置文件中加入下面一段：</p>
<p>Code highlighting produced by Actipro CodeHighlighter (freeware)<br />
http://www.CodeHighlighter.com/</p>
<p>--&gt;&lt;prebuild&gt; &nbsp;&nbsp;&nbsp;&nbsp;&lt;modificationWriter&gt; &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;filename&gt;mods.xml&lt;/filename&gt; &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;path&gt;x:\ccnet\svn\build&lt;/path&gt; &nbsp;&nbsp;&nbsp;&nbsp;&lt;/modificationWriter&gt; &lt;/prebuild&gt;</p>
<p>这样，每当CCNET更新SVN代码时，都会将SVN的更新记录到mods.xml中，mods.xml的格式大致如下：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg" /></p>
<p>Code highlighting produced by Actipro CodeHighlighter (freeware)<br />
http://www.CodeHighlighter.com/</p>
<p>--&gt;&lt;?xml&nbsp;version="1.0"&nbsp;encoding="utf-8"?&gt; &lt;ArrayOfModification&nbsp;xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"&nbsp;xmlns:xsd="http://www.w3.org/2001/XMLSchema"&gt; &nbsp;&nbsp;&nbsp;&nbsp;&lt;Modification&gt; &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;Type&gt;Modified&lt;/Type&gt; &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;FileName&gt;xxx.cs&lt;/FileName&gt; &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;FolderName&gt;/trunk/ProjectA/&lt;/FolderName&gt; &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;ModifiedTime&gt;2009-04-05T16:09:58.545196+08:00&lt;/ModifiedTime&gt; &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;UserName&gt;coderzh&lt;/UserName&gt; &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;ChangeNumber&gt;8888&lt;/ChangeNumber&gt; &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;Version&nbsp;/&gt; &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;Comment&gt;Upload&nbsp;My&nbsp;Greate&nbsp;Code&lt;/Comment&gt; &nbsp;&nbsp;&nbsp;&nbsp;&lt;/Modification&gt; &lt;/ArrayOfModification&gt;</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg" /></p>
<p>回到正题，通过读取mods.xml知道CCNET此次编译前更新的代码后，如何判断改代码文件属于哪个工程呢？很容易想到的就是通过路径判断，比如上面的代码的FolderName是/trunk/ProjectA，我们就能断定该代码文件属于ProjectA。当然，我们还需要一个配置文件，用于说明哪些目录下的代码属于哪个工程，即代码文件与工程的对应关系。这些信息我们可以直接在MSBuild的配置文件中设置：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg" /></p>
<p>Code highlighting produced by Actipro CodeHighlighter (freeware)<br />
http://www.CodeHighlighter.com/</p>
<p>--&gt;&lt;PropertyGroup&gt; &nbsp;&nbsp;&nbsp;&nbsp;&lt;FrameworkAPath&gt;\trunk\Framework&lt;/FrameworkAPath&gt; &nbsp;&nbsp;&nbsp;&nbsp;&lt;ProjectA&gt;\trunk\ProjectA&lt;/ProjectA&gt; &nbsp;&nbsp;&nbsp;&nbsp;&lt;ProjectB&gt;\trunk\ProjectB&lt;/ProjectB&gt; &nbsp;&nbsp;&nbsp;&nbsp;&lt;ProjectC&gt;\trunk\ProjectC&lt;/ProjectC&gt; &lt;/PropertyGroup&gt; &lt;ItemGroup&gt; &nbsp;&nbsp;&nbsp;&nbsp;&lt;SvnFolder&nbsp;Include="$(FrameworkAPath);"&gt; &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;ProjectName&gt;FrameworkA&lt;/ProjectName&gt; &nbsp;&nbsp;&nbsp;&nbsp;&lt;/SvnFolder&gt; &nbsp;&nbsp;&nbsp;&nbsp;&lt;SvnFolder&nbsp;Include="$(ProjectAPath);"&gt; &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;ProjectName&gt;ProjectA&lt;/ProjectName&gt; &nbsp;&nbsp;&nbsp;&nbsp;&lt;/SvnFolder&gt; &nbsp;&nbsp;&nbsp;&nbsp;&lt;SvnFolder&nbsp;Include="$(ProjectBPath);"&gt; &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;ProjectName&gt;ProjectB&lt;/ProjectName&gt; &nbsp;&nbsp;&nbsp;&nbsp;&lt;/SvnFolder&gt; &nbsp;&nbsp;&nbsp;&nbsp;&lt;SvnFolder&nbsp;Include="$(ProjectCPath"&gt; &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;ProjectName&gt;ProjectC&lt;/ProjectName&gt; &nbsp;&nbsp;&nbsp;&nbsp;&lt;/SvnFolder&gt; &lt;/ItemGroup&gt;</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg" /></p>
<p>OK，我们的第一个问题解决了，接下来的问题是，如何设置工程间的这种关联关系。同样的，我们通过MSBuild配置文件中的Target来设置，我们看下面的配置就会明白了：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg" /></p>
<p>Code highlighting produced by Actipro CodeHighlighter (freeware)<br />
http://www.CodeHighlighter.com/</p>
<p>--&gt;&lt;Target&nbsp;Name="FrameworkA"&gt; &nbsp;&nbsp;&nbsp;&nbsp;&lt;MSBuild&nbsp;Projects="$(FrameworkAPath)\FrameworkA.sln"&nbsp;Properties="Configuration=Release"/&gt; &nbsp;&nbsp;&nbsp;&nbsp;&lt;CallTarget&nbsp;Targets="ProjectA"&nbsp;/&gt;&nbsp;&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;&nbsp;&lt;CallTarget&nbsp;Targets="ProjectB"&nbsp;/&gt; &nbsp;&nbsp;&nbsp;&nbsp;&lt;CallTarget&nbsp;Targets="ProjectC"&nbsp;/&gt; &lt;/Target&gt; &lt;Target&nbsp;Name="ProjectA"&gt; &nbsp;&nbsp;&nbsp;&nbsp;&lt;MSBuild&nbsp;Projects="$(ProjectAPath)\ProjectA.sln"&nbsp;Properties="Configuration=Release"/&gt; &lt;/Target&gt; &lt;Target&nbsp;Name="ProjectB"&gt; &nbsp;&nbsp;&nbsp;&nbsp;&lt;MSBuild&nbsp;Projects="$(ProjectBPath)\ProjectB.sln"&nbsp;Properties="Configuration=Release"/&gt; &lt;/Target&gt; &lt;Target&nbsp;Name="ProjectC"&gt; &nbsp;&nbsp;&nbsp;&nbsp;&lt;MSBuild&nbsp;Projects="$(ProjectCPath)\ProjectC.sln"&nbsp;Properties="Configuration=Release"/&gt; &lt;/Target&gt;</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg" /></p>
<p>我们看到，我们通过Target的设置成功的将不同工程联系了起来，当我们需要编译FrameworkA时，我们只需要调用FrameworkA这个Target，它会先FrameworkA编译，然后再调用ProjectA，ProjectB，ProjectC的编译。</p>
<p>哈哈，一切准备工作都就绪了，我们需要在MSBuild的扩展Task里完成的任务就是：</p>
<p>1. 读取mods.xml，自动判断入库代码所属工程。</p>
<p>2. 返回需要编译的工程名列表。</p>
<p>我们在VS里建立一个DLL工程，然后添加Microsoft.Build.Utilities和Microsoft.Build.Framework的引用，然后编写我们自定义的Task类，我取名为MyTask，让它继承Task类，我们要做的是重写其中的Execute方法。MSBuild具体的Task写法请参照<a href="http://msdn.microsoft.com/en-us/library/t9883dzc.aspx" rel="external nofollow noreferrer">How to write a Task</a>，我这里不再重复了，下面是的MyTask代码：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0NvbnRyYWN0ZWRCbG9jay5naWY=.jpg" /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0V4cGFuZGVkQmxvY2tTdGFydC5naWY=.jpg" />MyTask</p>
<p>Code highlighting produced by Actipro CodeHighlighter (freeware)<br />
http://www.CodeHighlighter.com/</p>
<p>--&gt;<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL05vbmUuZ2lm.jpg" />using&nbsp;System; <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL05vbmUuZ2lm.jpg" />using&nbsp;System.Collections.Generic; <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL05vbmUuZ2lm.jpg" />using&nbsp;System.Linq; <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL05vbmUuZ2lm.jpg" />using&nbsp;System.Text; <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL05vbmUuZ2lm.jpg" />using&nbsp;Microsoft.Build.Utilities; <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL05vbmUuZ2lm.jpg" />using&nbsp;System.Xml; <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL05vbmUuZ2lm.jpg" />using&nbsp;System.Collections; <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL05vbmUuZ2lm.jpg" />using&nbsp;Microsoft.Build.Framework; <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL05vbmUuZ2lm.jpg" />using&nbsp;System.IO; <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL05vbmUuZ2lm.jpg" /> <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL05vbmUuZ2lm.jpg" />namespace&nbsp;CoderZh.MyTask <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0V4cGFuZGVkQmxvY2tTdGFydC5naWY=.jpg" /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0NvbnRyYWN0ZWRCbG9jay5naWY=.jpg" /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9kb3QuZ2lm.jpg" />{ <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;public&nbsp;class&nbsp;MyTask&nbsp;:&nbsp;Task <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0V4cGFuZGVkU3ViQmxvY2tTdGFydC5naWY=.jpg" /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0NvbnRyYWN0ZWRTdWJCbG9jay5naWY=.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9kb3QuZ2lm.jpg" />{ <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;[Output] <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0V4cGFuZGVkU3ViQmxvY2tTdGFydC5naWY=.jpg" /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0NvbnRyYWN0ZWRTdWJCbG9jay5naWY=.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;public&nbsp;ITaskItem[]&nbsp;Targets&nbsp;<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9kb3QuZ2lm.jpg" />{&nbsp;get;&nbsp;set;&nbsp;} <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" /> <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;[Required] <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0V4cGFuZGVkU3ViQmxvY2tTdGFydC5naWY=.jpg" /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0NvbnRyYWN0ZWRTdWJCbG9jay5naWY=.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;public&nbsp;ITaskItem[]&nbsp;Projects&nbsp;<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9kb3QuZ2lm.jpg" />{&nbsp;get;&nbsp;set;&nbsp;} <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" /> <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;[Required] <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0V4cGFuZGVkU3ViQmxvY2tTdGFydC5naWY=.jpg" /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0NvbnRyYWN0ZWRTdWJCbG9jay5naWY=.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;public&nbsp;string&nbsp;SvnModifyFile&nbsp;<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9kb3QuZ2lm.jpg" />{&nbsp;get;&nbsp;set;&nbsp;} <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" /> <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;[Required] <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0V4cGFuZGVkU3ViQmxvY2tTdGFydC5naWY=.jpg" /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0NvbnRyYWN0ZWRTdWJCbG9jay5naWY=.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;public&nbsp;string&nbsp;StateFile&nbsp;<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9kb3QuZ2lm.jpg" />{&nbsp;get;&nbsp;set;&nbsp;} <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" /> <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;private&nbsp;DateTime&nbsp;curBuildTime; <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;private&nbsp;DateTime&nbsp;lastBuildTime; <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;private&nbsp;Boolean&nbsp;lastBuildResult&nbsp;=&nbsp;false; <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" /> <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0V4cGFuZGVkU3ViQmxvY2tTdGFydC5naWY=.jpg" /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0NvbnRyYWN0ZWRTdWJCbG9jay5naWY=.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;/**////&nbsp;&lt;summary&gt; <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;///&nbsp;My&nbsp;Task&nbsp;Run&nbsp;From&nbsp;Here <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;///&nbsp;&lt;/summary&gt; <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0V4cGFuZGVkU3ViQmxvY2tFbmQuZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;///&nbsp;&lt;returns&gt;&lt;/returns&gt; <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;public&nbsp;override&nbsp;bool&nbsp;Execute() <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0V4cGFuZGVkU3ViQmxvY2tTdGFydC5naWY=.jpg" /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0NvbnRyYWN0ZWRTdWJCbG9jay5naWY=.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9kb3QuZ2lm.jpg" />{ <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;if&nbsp;((this.Projects&nbsp;==&nbsp;null)&nbsp;||&nbsp;(this.Projects.Length&nbsp;==&nbsp;0)) <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0V4cGFuZGVkU3ViQmxvY2tTdGFydC5naWY=.jpg" /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0NvbnRyYWN0ZWRTdWJCbG9jay5naWY=.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9kb3QuZ2lm.jpg" />{ <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;return&nbsp;true; <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0V4cGFuZGVkU3ViQmxvY2tFbmQuZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;} <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" /> <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//Read&nbsp;last&nbsp;build&nbsp;time&nbsp;and&nbsp;result <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;this.ReadLastBuildStatus(); <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" /> <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;if&nbsp;(!this.lastBuildResult&nbsp;||&nbsp;this.lastBuildTime.Day&nbsp;!=&nbsp;DateTime.Now.Day) <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0V4cGFuZGVkU3ViQmxvY2tTdGFydC5naWY=.jpg" /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0NvbnRyYWN0ZWRTdWJCbG9jay5naWY=.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9kb3QuZ2lm.jpg" />{//If&nbsp;last&nbsp;build&nbsp;fail,&nbsp;or&nbsp;it&nbsp;is&nbsp;another&nbsp;day,&nbsp;then&nbsp;run&nbsp;all&nbsp;the&nbsp;targets <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Log.LogMessage("Last&nbsp;build&nbsp;fail,&nbsp;or&nbsp;it&nbsp;is&nbsp;another&nbsp;day,&nbsp;then&nbsp;run&nbsp;all&nbsp;the&nbsp;targets"); <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;this.SetAllTargetsToRun(); <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0V4cGFuZGVkU3ViQmxvY2tFbmQuZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;} <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;else <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0V4cGFuZGVkU3ViQmxvY2tTdGFydC5naWY=.jpg" /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0NvbnRyYWN0ZWRTdWJCbG9jay5naWY=.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9kb3QuZ2lm.jpg" />{//check&nbsp;the&nbsp;svn&nbsp;and&nbsp;run&nbsp;the&nbsp;specify&nbsp;targets <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;this.SetTargetsToRunBySvnModify(); <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0V4cGFuZGVkU3ViQmxvY2tFbmQuZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;} <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" /> <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;return&nbsp;true; <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0V4cGFuZGVkU3ViQmxvY2tFbmQuZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;} <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" /> <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" /> <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0V4cGFuZGVkU3ViQmxvY2tTdGFydC5naWY=.jpg" /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0NvbnRyYWN0ZWRTdWJCbG9jay5naWY=.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;/**////&nbsp;&lt;summary&gt; <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;///&nbsp;Read&nbsp;Last&nbsp;Build&nbsp;Result,&nbsp;Success&nbsp;Or&nbsp;Not <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0V4cGFuZGVkU3ViQmxvY2tFbmQuZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;///&nbsp;&lt;/summary&gt; <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;private&nbsp;void&nbsp;ReadLastBuildStatus() <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0V4cGFuZGVkU3ViQmxvY2tTdGFydC5naWY=.jpg" /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0NvbnRyYWN0ZWRTdWJCbG9jay5naWY=.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9kb3QuZ2lm.jpg" />{ <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;try <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0V4cGFuZGVkU3ViQmxvY2tTdGFydC5naWY=.jpg" /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0NvbnRyYWN0ZWRTdWJCbG9jay5naWY=.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9kb3QuZ2lm.jpg" />{ <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;XmlDocument&nbsp;doc&nbsp;=&nbsp;new&nbsp;XmlDocument(); <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;doc.Load(this.StateFile); <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;XmlNode&nbsp;lastBuildTimeNode&nbsp;=&nbsp;doc.SelectSingleNode("/IntegrationResult/StartTime"); <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;this.lastBuildTime&nbsp;=&nbsp;Convert.ToDateTime(lastBuildTimeNode.InnerText); <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" /> <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;XmlNode&nbsp;lastBuildResultNode&nbsp;=&nbsp;doc.SelectSingleNode("/IntegrationResult/LastIntegrationStatus"); <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;this.lastBuildResult&nbsp;=&nbsp;lastBuildResultNode.InnerText.ToLower()&nbsp;==&nbsp;"success"; <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" /> <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Log.LogMessage("Load&nbsp;from&nbsp;:&nbsp;{0}\r\nLastBuild&nbsp;Time&nbsp;:&nbsp;{1}\r\nLastBuild&nbsp;Result&nbsp;:&nbsp;{2}", <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;this.StateFile,&nbsp;this.lastBuildTime.ToString(),&nbsp;this.lastBuildResult.ToString()); <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;doc&nbsp;=&nbsp;null; <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0V4cGFuZGVkU3ViQmxvY2tFbmQuZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;} <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;catch(Exception&nbsp;ex) <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0V4cGFuZGVkU3ViQmxvY2tTdGFydC5naWY=.jpg" /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0NvbnRyYWN0ZWRTdWJCbG9jay5naWY=.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9kb3QuZ2lm.jpg" />{ <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Log.LogWarningFromException(ex); <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;this.lastBuildTime&nbsp;=&nbsp;DateTime.Today.AddDays(-1.0); <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;this.lastBuildResult&nbsp;=&nbsp;false; <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0V4cGFuZGVkU3ViQmxvY2tFbmQuZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;} <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0V4cGFuZGVkU3ViQmxvY2tFbmQuZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;} <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" /> <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0V4cGFuZGVkU3ViQmxvY2tTdGFydC5naWY=.jpg" /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0NvbnRyYWN0ZWRTdWJCbG9jay5naWY=.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;/**////&nbsp;&lt;summary&gt; <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;///&nbsp;Set&nbsp;All&nbsp;targets&nbsp;to&nbsp;run <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0V4cGFuZGVkU3ViQmxvY2tFbmQuZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;///&nbsp;&lt;/summary&gt; <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;private&nbsp;void&nbsp;SetAllTargetsToRun() <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0V4cGFuZGVkU3ViQmxvY2tTdGFydC5naWY=.jpg" /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0NvbnRyYWN0ZWRTdWJCbG9jay5naWY=.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9kb3QuZ2lm.jpg" />{ <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;ArrayList&nbsp;list&nbsp;=&nbsp;new&nbsp;ArrayList(); <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;foreach&nbsp;(ITaskItem&nbsp;item&nbsp;in&nbsp;this.Projects) <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0V4cGFuZGVkU3ViQmxvY2tTdGFydC5naWY=.jpg" /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0NvbnRyYWN0ZWRTdWJCbG9jay5naWY=.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9kb3QuZ2lm.jpg" />{ <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;string&nbsp;targetName&nbsp;=&nbsp;item.GetMetadata("ProjectName"); <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;if&nbsp;(!list.Contains(targetName)) <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0V4cGFuZGVkU3ViQmxvY2tTdGFydC5naWY=.jpg" /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0NvbnRyYWN0ZWRTdWJCbG9jay5naWY=.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9kb3QuZ2lm.jpg" />{ <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;list.Add(targetName); <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0V4cGFuZGVkU3ViQmxvY2tFbmQuZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;} <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0V4cGFuZGVkU3ViQmxvY2tFbmQuZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;} <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;ArrayList&nbsp;targetList&nbsp;=&nbsp;new&nbsp;ArrayList(); <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;foreach&nbsp;(string&nbsp;item&nbsp;in&nbsp;list) <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0V4cGFuZGVkU3ViQmxvY2tTdGFydC5naWY=.jpg" /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0NvbnRyYWN0ZWRTdWJCbG9jay5naWY=.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9kb3QuZ2lm.jpg" />{ <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;targetList.Add(new&nbsp;TaskItem(item)); <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0V4cGFuZGVkU3ViQmxvY2tFbmQuZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;} <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;this.Targets&nbsp;=&nbsp;(ITaskItem[])targetList.ToArray(typeof(ITaskItem)); <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0V4cGFuZGVkU3ViQmxvY2tFbmQuZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;} <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" /> <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0V4cGFuZGVkU3ViQmxvY2tTdGFydC5naWY=.jpg" /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0NvbnRyYWN0ZWRTdWJCbG9jay5naWY=.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;/**////&nbsp;&lt;summary&gt; <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;///&nbsp;Set&nbsp;Targets&nbsp;to&nbsp;run&nbsp;by&nbsp;SVN&nbsp;Modify <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0V4cGFuZGVkU3ViQmxvY2tFbmQuZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;///&nbsp;&lt;/summary&gt; <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;private&nbsp;void&nbsp;SetTargetsToRunBySvnModify() <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0V4cGFuZGVkU3ViQmxvY2tTdGFydC5naWY=.jpg" /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0NvbnRyYWN0ZWRTdWJCbG9jay5naWY=.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9kb3QuZ2lm.jpg" />{ <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;this.curBuildTime&nbsp;=&nbsp;DateTime.Now; <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" /> <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;ArrayList&nbsp;list&nbsp;=&nbsp;new&nbsp;ArrayList(); <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" /> <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;List&lt;string&gt;&nbsp;mods&nbsp;=&nbsp;GetModification(); <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;foreach&nbsp;(ITaskItem&nbsp;item&nbsp;in&nbsp;this.Projects) <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0V4cGFuZGVkU3ViQmxvY2tTdGFydC5naWY=.jpg" /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0NvbnRyYWN0ZWRTdWJCbG9jay5naWY=.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9kb3QuZ2lm.jpg" />{ <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;string&nbsp;projectFolder&nbsp;=&nbsp;Path.GetFullPath(item.ItemSpec); <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;string&nbsp;excludeFolder&nbsp;=&nbsp;item.GetMetadata("Exclude"); <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;excludeFolder&nbsp;=&nbsp;String.IsNullOrEmpty(excludeFolder)&nbsp;?&nbsp;String.Empty&nbsp;:&nbsp;Path.GetFullPath(excludeFolder); <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Log.LogMessage("\nprojectFolder:"&nbsp;+&nbsp;projectFolder); <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;foreach&nbsp;(string&nbsp;mod&nbsp;in&nbsp;mods) <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0V4cGFuZGVkU3ViQmxvY2tTdGFydC5naWY=.jpg" /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0NvbnRyYWN0ZWRTdWJCbG9jay5naWY=.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9kb3QuZ2lm.jpg" />{ <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;string&nbsp;modifyFolder&nbsp;=&nbsp;Path.GetFullPath(mod.Replace(@"/trunk",&nbsp;"..")); <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Log.LogMessage("\t--&nbsp;modifyFolder:"&nbsp;+&nbsp;modifyFolder); <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;if&nbsp;(modifyFolder.Contains(projectFolder)) <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0V4cGFuZGVkU3ViQmxvY2tTdGFydC5naWY=.jpg" /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0NvbnRyYWN0ZWRTdWJCbG9jay5naWY=.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9kb3QuZ2lm.jpg" />{ <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;if&nbsp;(!String.IsNullOrEmpty(excludeFolder)&nbsp;&amp;&amp;&nbsp;modifyFolder.Contains(excludeFolder)) <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0V4cGFuZGVkU3ViQmxvY2tTdGFydC5naWY=.jpg" /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0NvbnRyYWN0ZWRTdWJCbG9jay5naWY=.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9kb3QuZ2lm.jpg" />{ <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Log.LogMessage("Exclude&nbsp;:&nbsp;{0}",&nbsp;excludeFolder); <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;continue; <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0V4cGFuZGVkU3ViQmxvY2tFbmQuZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;} <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" /> <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;string&nbsp;targetName&nbsp;=&nbsp;item.GetMetadata("ProjectName"); <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Log.LogMessage("Matched&nbsp;:&nbsp;{0}",&nbsp;targetName); <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;list.Add(new&nbsp;TaskItem(targetName)); <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;break; <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0V4cGFuZGVkU3ViQmxvY2tFbmQuZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;} <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0V4cGFuZGVkU3ViQmxvY2tFbmQuZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;} <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0V4cGFuZGVkU3ViQmxvY2tFbmQuZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;} <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;this.Targets&nbsp;=&nbsp;(ITaskItem[])list.ToArray(typeof(ITaskItem)); <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" /> <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0V4cGFuZGVkU3ViQmxvY2tFbmQuZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;} <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" /> <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0V4cGFuZGVkU3ViQmxvY2tTdGFydC5naWY=.jpg" /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0NvbnRyYWN0ZWRTdWJCbG9jay5naWY=.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;/**////&nbsp;&lt;summary&gt; <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;///&nbsp;Get&nbsp;Modification&nbsp;From&nbsp;mods.xml <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;///&nbsp;&lt;/summary&gt; <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0V4cGFuZGVkU3ViQmxvY2tFbmQuZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;///&nbsp;&lt;returns&gt;&lt;/returns&gt; <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;private&nbsp;List&lt;string&gt;&nbsp;GetModification() <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0V4cGFuZGVkU3ViQmxvY2tTdGFydC5naWY=.jpg" /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0NvbnRyYWN0ZWRTdWJCbG9jay5naWY=.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9kb3QuZ2lm.jpg" />{ <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;List&lt;string&gt;&nbsp;modList&nbsp;=&nbsp;new&nbsp;List&lt;string&gt;(); <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;try <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0V4cGFuZGVkU3ViQmxvY2tTdGFydC5naWY=.jpg" /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0NvbnRyYWN0ZWRTdWJCbG9jay5naWY=.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9kb3QuZ2lm.jpg" />{ <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;XmlDocument&nbsp;doc&nbsp;=&nbsp;new&nbsp;XmlDocument(); <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;doc.Load(this.SvnModifyFile); <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;XmlNodeList&nbsp;modNodeList&nbsp;=&nbsp;doc.SelectNodes("/ArrayOfModification/Modification"); <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;foreach&nbsp;(XmlNode&nbsp;modNode&nbsp;in&nbsp;modNodeList) <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0V4cGFuZGVkU3ViQmxvY2tTdGFydC5naWY=.jpg" /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0NvbnRyYWN0ZWRTdWJCbG9jay5naWY=.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9kb3QuZ2lm.jpg" />{ <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;XmlNode&nbsp;folderNode&nbsp;=&nbsp;modNode.SelectSingleNode("FolderName"); <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;modList.Add(folderNode.InnerText); <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0V4cGFuZGVkU3ViQmxvY2tFbmQuZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;} <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;doc&nbsp;=&nbsp;null; <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0V4cGFuZGVkU3ViQmxvY2tFbmQuZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;} <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;catch&nbsp;(Exception&nbsp;ex) <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0V4cGFuZGVkU3ViQmxvY2tTdGFydC5naWY=.jpg" /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0NvbnRyYWN0ZWRTdWJCbG9jay5naWY=.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9kb3QuZ2lm.jpg" />{ <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Log.LogWarningFromException(ex); <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0V4cGFuZGVkU3ViQmxvY2tFbmQuZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;} <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;return&nbsp;modList; <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0V4cGFuZGVkU3ViQmxvY2tFbmQuZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;} <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0V4cGFuZGVkU3ViQmxvY2tFbmQuZ2lm.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;} <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNuYmxvZ3MuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0V4cGFuZGVkQmxvY2tFbmQuZ2lm.jpg" />}</p>
<p>接下来完成最后一步，配置完成我们的MSBuild配置文件。我们添加MyTask相关的内容：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg" /></p>
<p>Code highlighting produced by Actipro CodeHighlighter (freeware)<br />
http://www.CodeHighlighter.com/</p>
<p>--&gt;&lt;UsingTask AssemblyFile="CoderZh.MyTask.dll" TaskName="MyTask"/&gt; &lt;Target&nbsp;Name="Build"&gt; &nbsp;&nbsp;&nbsp;&nbsp;&lt;MyTask&nbsp;SvnModifyFile="$(SvnModifyFile)"&nbsp;StateFile="$(CCNetStateFile)"&nbsp;Projects="@(SvnFolder)"&gt; &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;Output&nbsp;TaskParameter="Targets"&nbsp;ItemName="TargetNames"&nbsp;/&gt; &nbsp;&nbsp;&nbsp;&nbsp;&lt;/MyTask&gt; &nbsp;&nbsp;&nbsp;&nbsp;&lt;Message&nbsp;Text="Targets&nbsp;to&nbsp;be&nbsp;call:@(TargetNames)"/&gt; &nbsp;&nbsp;&nbsp;&nbsp;&lt;CallTarget&nbsp;Targets="@(TargetNames)"&nbsp;/&gt; &lt;/Target&gt;</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg" /></p>
<p>OK，搞定！</p>
<h4>三、总结</h4>
<p>通过上面的方法，我们实现了：</p>
<p>1.CCNET只更新需要编译的工程代码，大大减少了SVN更新的时间，同时，也减少了SVN编译的次数。</p>
<p>2.我们实现了只编译入库代码所属工程，以及其相关联的工程。大大减少了编译工程的范围，缩短了编译时间。</p>
<p>我也知道，上面的解决方案不够完美，也许有更加直接，简单的处理办法，也请大家拿出来讨论讨论，不甚感激。</p>
<p>本文相关的配置文件及代码如下，希望对大家有微薄之助。</p>
<p>代码：<a href="http://files.cnblogs.com/coderzh/mytask/MyBuild.rar" rel="external nofollow noreferrer">/Files/coderzh/mytask/MyBuild.rar</a></p>
<p>MSBuild 配置文件：<a href="http://files.cnblogs.com/coderzh/mytask/mybuild.txt" rel="external nofollow noreferrer">/Files/coderzh/mytask/mybuild.txt</a></p>
<p>CCNET配置文件：<a href="http://files.cnblogs.com/coderzh/mytask/ccnet.txt" rel="external nofollow noreferrer">/Files/coderzh/mytask/ccnet.txt</a></p>
<p>本文转载自：http://www.cnblogs.com/coderzh/archive/2009/04/05/1429858.html</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-20 16:23:35 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>CCNET+MSBuild+SVN实时构建的优化总结的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/35wkEVM.html" rel="bookmark">Mac下Jenkins&plus;SVN&plus;Xcode构建持续</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1 安装Jenkins Jenkins是基于Java开发的一种持续集成工具.所以呢,要使用Jenkins必须使用先安装JDK. JDK安装 JDK 下载地址 jdk 1.8.png 安装JDK的过程略,别说你不会安装(如有不会安装的,自行百度). Jenkins安装 Jenkins 下载地址 Jenkins安装文件.png 点击图中 Mac OS X,会自动下载[jenkins-1.644.pkg]安装过程略(双击jenkins-1.644.pkg后,下一步就OK了). 注意: 1.Jenkin			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MBKrAq0.html" rel="bookmark">ROS 实时构建八叉树模型</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				ROS 实时构建八叉树模型 ROS 毕业设计的主要内容是室内环境的建模,并转换成八叉树模型,以供后续使用之需.这里介绍离线八叉树模型建立和实时的八叉树环境模型构建. 1. 环境搭建 平台: ubuntu下ROS,用过hydro和indigo,其他版本有待确认(ros的安装请参考ros wiki): 开源室内建模项目,ROS下了解的RGBD开源项目有RGBD_SLAM和rtabmap,这里使用的是rtabmap,rtabmap的安装请参考ros rtabmap. ros下的octomap包,安装$			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0l28bW4.html" rel="bookmark">Docker镜像构建的优化总结</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Docker镜像构建的优化总结 随着我们对docker镜像的持续使用,在此过程中如果不加以注意并且优化,镜像的体积会越来越多.很多时候我们在使用docker部署应用时,会发现镜像的体积至少有1G以上.镜像体积的增大,不单单会增加磁盘资源与网络资源的开销,也会影响应用的部署效率,使得应用的部署时间会越来越长.因此我们需要减少部署镜像的体积以加快部署效率,降低资源的开销.而对于镜像的优化,可以通过对dockerfile的优化来实现. 一.镜像最小化 1.选择最精简的基础镜像 选择体积最小的基础镜像可			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/kML8OyM.html" rel="bookmark">（持续集成）win7上部署Jenkins&plus;MSBuild&plus;Svn&plus;SonarQube&plus;SonarQube Scanner for MSBuild （一）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.Jenkins介绍 jenkins是一个广泛用于持续构建的可视化web工具,持续构建说得更直白点,就是各种项目的”自动化”编译.打包.分发部署.jenkins可以很好的支持各种语言(比如:java, c#, php等)的项目构建,也完全兼容ant.maven.gradle等多种第三方构建工具,同时跟svn.git能无缝集成,也支持直接与知名源代码托管网站,比如github.bitbucket直接集成. jenkins官网地址为https://jenkins.io/index.html,jen			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0xryj74.html" rel="bookmark">Jenkins配置MSBuild实现自动部署（MSBuild&plus;SVN&sol;Subversion&plus;FTP&plus;BAT）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				所要用到的主要插件: [MSBuild Plugin] 具体操作: 1.配置MSBuild的版本 [系统管理]-&gt;[Global Tool Configuration]-&gt;[MSBuild],点击[新增MSBuild]进行版本的添加,如下: 注意:其中Path to MSBuild为文件夹路径,代码要编译的那台机器的文件夹,如果绑定的是slave时,这个路径就代表这slave的路径 最后,点击[Save]完成保存. 2.新建项目进行测试 这里假设在要进行构建的机器上已经新建好项目,并放在“D:			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MVVAjyM.html" rel="bookmark">（持续集成）win7上部署Jenkins&plus;MSBuild&plus;Svn&plus;SonarQube&plus;SonarQube Scanner for MSBuild （第二发）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				这一篇进入实战,走起.... 登录jenkins,如下图 点击上图中的“新建”按钮,进入下图 输入项目名称,选择“构建一个自由风格的软件项目”即可,点击“ok”,跳转到下图 svn源代码管理(选择代码管理器中的subversion) 构建触发器信息维护(什么时候down源代码到本地) 第一个的意思是远程触发构建,就是访问url的方式触发构建 第二个的意思是另一个项目构建完成后,进行构建 第三个的意思是定时去构建(不论源代码是否有新的commit) 第四个略过 第五个定期去构建(有新的commit			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0bewBLM.html" rel="bookmark">SVN &plus; Jinkins 构建自动部署</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1. 前言 因为研发部门不想把他们的源代码 git 到服务器再编译,git + maven + jenkins 的方式行不通,于是采用 svn + jenkins的方式,流程如下: 只需要 程序员 手动提交到svn ,后面的事件都是由 jenkins 自动完成的. 2. 实现过程 环境介绍 2.1 svn 服务器搭建 时间同步.selinux .iptables 这些初始化工作就不在说了. 安装svn程序包 [[email protected] ~]#yum install subversion			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0KYpXm4.html" rel="bookmark">构建和优化深度学习模型（神经网络机器识图）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				DSL(Deep Learning Service)是基于华为云强大高性能计算提供一站式深度学习平台服务,内置大量优化的网络模型算法,以兼容.便携.高效的品质帮助用户轻松使用深度学习技术,通过灵活调度按需服务化方式提供模型训练.评估与预测. 深度学习训练模型:数据准备--&gt;数据模型训练(优化参数)--&gt;反馈损失值--&gt;更多训练 评估模型:返回结果为预测值与测试数据集标注值的错误率或准确率 深度学习模型的优化方法? 训练次数的调整? 代价函数的调整? 学习率的调整? 训练算法的优化? 神经			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MVlbXj3.html" rel="bookmark">webpack构建速度优化-记录一次公司项目build优化&lpar;不完全记录&rpar;仅供翻阅参考</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				打包速度 转化AST—&gt;遍历树—&gt;转化回代码(具体语法配置参考webpack,这边只是个人的一些过程记录,并不包含详细过程)1.缓存 cache-loader2.多核 happypack threads3.抽离 DllPlugin.externals4.拆分 Docker 优化项目:测量插件speed-measure-webpack-plugin 用法: 优化前:可以看到我们公司的项目还是比较残暴的!!开启AOT(Angular5项目)之后,线上构建达到了41分钟! 测量出现的问题:raw-l			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/412wNXM.html" rel="bookmark" class="title">Cocos2d-x 3&period;0修改Android平台帧率fps - 解决游戏运行手机发热发烫问题</a>
					<div>
						使用Cocos2d-x 3.0开发游戏之后,发现游戏在android手机上发热非常严重,在魅族2上,几乎担心手机会爆炸了~~~采取的一个措施就是降低帧率,因为游戏对于帧率要求不是非常高. 做过coco ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0eAadJ0.html" rel="bookmark" class="title">物联网操作系统HelloX开发者入门指南</a>
					<div>
						HelloX开发者入门指南 HelloX是聚焦于物联网领域的操作系统开发项目,可以通过百度搜索&quot;HelloX&quot;,获取详细信息.当前开发团队正在进一步招募中,欢迎您的了解和加入.如果 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0RBxG70.html" rel="bookmark" class="title">THINKPHP框架NGINX重写配置</a>
					<div>
						server { listen 80; server_name 域名; root APP地址; index index.php; error_page 400 /errpage/400.html; e ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3r2mXq3.html" rel="bookmark" class="title">Linux运维基础命令笔试题--看看你会多少？</a>
					<div>
						老男孩Linux运维基础2728期课后学习效果上机闭卷考试题详解 http://edu.51cto.com/course/course_id-5577.html 如果你觉得不错,请为他点赞和评价.这样 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mg5Lpr3.html" rel="bookmark" class="title">Java访问权限控制</a>
					<div>
						访问权限控制   java提供了访问权限修饰词,以供类库开发人员向客户端程序员指明哪些是可用的,哪些是不可用的.访问权限控制的等级,从最大权限到最小权限依次是:public.protected.包访问 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02DkWD4.html" rel="bookmark" class="title">android sqlite 数据库升级</a>
					<div>
						场景: 数据库版本v1            有一个persion表 数据库版本v2             新增表student 数据库版本v3             persion表新增一个字段 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0nv28o0.html" rel="bookmark" class="title">那些年的网站负载技术</a>
					<div>
						Internet的规模每一百天就会增长一倍,客户希望获得7天24小时的不间断可用性及较快的系统反应时间,而不愿屡次看到某个站点&quot;Server Too Busy&quot;及频繁的系统故障.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0d5jXe3.html" rel="bookmark" class="title">【IOS】ASIHTTPRequest，ASIFormDataRequest</a>
					<div>
						1 //1. 2 NSString *postURL = [NSString stringWithFormat:@&quot;http://xxxxxx.php?model=%@&amp;data=% ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xRwnN4.html" rel="bookmark" class="title">7&period;07 生成累积乘积</a>
					<div>
						问题:计算某个数字列的累乘积.其操作方式与&quot;计算累计和&quot;相似,只是使用乘法而不是加法.解决方案:作为例子,本解决方案中都计算职员工资的累乘积.虽然工资的累乘积没有多大用处,然后可以 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qQ7Na3.html" rel="bookmark" class="title">《转载》【国际惯例】华为十年，干货送给后来人</a>
					<div>
						结合大家经常讨论的问题,以下有一点小收获,非经历贴非炫耀贴,分享给后来人,希望对困惑的人有所帮助:对或不对.听或不听,自行判断:觉得错的不用PEN了,本周五就截止了,有问题可以留言,我尽量答复. 第一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mz1JAW4.html" rel="bookmark" class="title">荷花在邮票中静静地绽放</a>
					<div>
						&quot;酷暑天,葵榴发,喷鼻香十里荷花&quot;,这是元代白朴所作的一首叫&lt;得胜乐·夏&gt;的诗词部分.盛夏时节,走近荷塘,欣闻十里荷花香.当亭亭玉立的荷花,一朵一朵地绽放在邮票之中的时 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3OZVWG0.html" rel="bookmark" class="title">iOS页面传值-wang</a>
					<div>
						iOS页面间传值的方式(NSUserDefault/Delegate/NSNotification/Block/单例) 实现了以下iOS页面间传值:1.委托delegate方式:2.通知notific ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0eENop0.html" rel="bookmark" class="title">unity关于中文字体显示问题</a>
					<div>
						在界面的字体显示问题,往往会碰到很多问题,比方工程里面是没有问题的,发布到移动端时却出现不显示问题.下面对Android于IOS的问题做下整理,只是针对动态字体. 1.Android Android由 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M6plNN3.html" rel="bookmark" class="title">华为OJ&mdash;&mdash;（练习用）挑7</a>
					<div>
						题目描述 输出7有关数字的个数,包括7的倍数,还有包含7的数字(如17,27,37...70,71,72,73...)的个数 输入描述: 一个正整数N.(N不大于30000) 输出描述: 不大于N的与 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xegkL3.html" rel="bookmark" class="title">Zend Studio集成Xdebug断点调试详解</a>
					<div>
						转自:http://www.softown.cn/post/115.html Xdebug是PHP开发中两个常用的断点调试工具之一(另一个为Zend Debugger). 现在,我们在Zend Stu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0dE21n3.html" rel="bookmark" class="title">浅谈栈&amp;amp&semi;&amp;amp&semi;进制转换</a>
					<div>
						利用stack实现进制转换 Stack.h #ifndef _STACK_H_ #define _STACK_H_ #include&lt;iostream&gt; #include&lt;asser ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wN1bY0.html" rel="bookmark" class="title">C&num; GMap&period;Net   计算多边形面积</a>
					<div>
						Cédric Bignon  : Let's note Points the points of the polygon (where Points[0] == Points[Points.Count ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0eazga0.html" rel="bookmark" class="title">Ajax&period;BeginForm参数详解</a>
					<div>
						在Asp.Net的MVC中的语法,在Razor页面中使用,替代JQuery的Ajax使用,方便快捷. 使用Ajax.BeginForm方法会生成一个form表单,最后以Ajax的方式提交表单数据:需要 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0RQXNpM.html" rel="bookmark" class="title">Bluez SPP实现代码分析&lpar;转&rpar;</a>
					<div>
						源:http://blog.csdn.net/walkingman321/article/details/7218705 本文分析蓝牙协议栈中蓝牙转串口(SPP)部分的实现. 1.  基本概念 Blu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rD1p1M.html" rel="bookmark" class="title">MySQL数据库的双向加密方式</a>
					<div>
						如果你正在运行使用MySQL的Web应用程序,那么你把密码或者其他敏感信息保存在应用程序里的机会就很大.保护这些数据免受或者窥探者的获取 是一个令人关注的重要问题,因为您既不能让未经授权的人员使用或者 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.071 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
